--- old/usr/src/cmd/file/file.c	Mon Jul  2 22:46:48 2012
+++ new/usr/src/cmd/file/file.c	Mon Jul  2 22:46:48 2012
@@ -30,6 +30,10 @@
  * Use is subject to license terms.
  */
 
+/*
+ * Copyright 2012, Josef 'Jeff' Sipek <jeffpc@31bits.net>. All rights reserved.
+ */
+
 #define	_LARGEFILE64_SOURCE
 
 /* Get definitions for the relocation types supported. */
@@ -141,6 +145,7 @@
 static int	ifd = -1;
 static int	elffd = -1;
 static int	tret;
+static int	sflg;
 static int	hflg;
 static int	dflg;
 static int	mflg;
@@ -218,7 +223,7 @@
 #endif
 	(void) textdomain(TEXT_DOMAIN);
 
-	while ((ch = getopt(argc, argv, "M:cdf:him:")) != EOF) {
+	while ((ch = getopt(argc, argv, "M:cdsf:him:")) != EOF) {
 		switch (ch) {
 
 		case 'M':
@@ -238,6 +243,10 @@
 			}
 			break;
 
+		case 's':
+			sflg++;
+			break;
+
 		case 'f':
 			fflg++;
 			errno = 0;
@@ -291,6 +300,8 @@
 	if (iflg && cflg) {
 		usage();
 	}
+	if (sflg && (iflg || cflg))
+		usage();
 
 	if (!dflg && !mflg && !M_flg && !iflg) {
 	/* no -d, -m, nor -M option; also -i option doesn't need magic  */
@@ -458,6 +469,8 @@
 		}
 		break;
 	case S_IFCHR:
+		if (sflg)
+			break;
 		(void) printf(gettext("character"));
 		goto spcl;
 
@@ -481,6 +494,8 @@
 		return (0);
 
 	case S_IFBLK:
+		if (sflg)
+			break;
 		(void) printf(gettext("block"));
 					/* major and minor, see sys/mkdev.h */
 spcl:
@@ -1645,8 +1660,8 @@
 usage(void)
 {
 	(void) fprintf(stderr, gettext(
-	    "usage: file [-dh] [-M mfile] [-m mfile] [-f ffile] file ...\n"
-	    "       file [-dh] [-M mfile] [-m mfile] -f ffile\n"
+	    "usage: file [-dhs] [-M mfile] [-m mfile] [-f ffile] file ...\n"
+	    "       file [-dhs] [-M mfile] [-m mfile] -f ffile\n"
 	    "       file -i [-h] [-f ffile] file ...\n"
 	    "       file -i [-h] -f ffile\n"
 	    "       file -c [-d] [-M mfile] [-m mfile]\n"));
